<?php
/**
 * @copyright	Copyright (C) 2011 Simplify Your Web, Inc. All rights reserved.
 * @license		GNU General Public License version 3 or later; see LICENSE.txt
 */

// no direct access
defined('_JEXEC') or die ;

jimport('joomla.form.formfield');

class JFormFieldGdtest extends JFormField {
		
	public $type = 'Gdtest';

	/**
	 * Method to get the field options.
	 *
	 * @return	array	The field option objects.
	 * @since	1.6
	 */
	protected function getLabel() {
		
		jimport('joomla.plugin.helper');	
		
		$error_msg_tmpl = '<div style="font-weight: bold; border: 3px solid red; background-color: #FFCCCC; font-size: 120%; margin: 10px 0 20px 0; padding: 3px; text-align: center">%error%</div>';
				
		$html = '';
		$value = trim($this->element['title']);
		
		$html .= '<div style="clear: both;"></div>';
		$html .= '<div style="margin: 20px 0 20px 0; font-weight: bold; padding: 5px; background-color: #F4F4F4;">';
		if ($value) {
			$html .= JText::_($value);
		}
		$html .= '</div>';		
		
		$extensions = get_loaded_extensions();
		
		if( !in_array( 'gd', $extensions ) ) {
			return $html .= str_replace('%error%', JText::_('MOD_LATESTNEWSENHANCED_GD_NOTLOADED'), $error_msg_tmpl);
		} else {
			$html .= '<p>'.JText::_('MOD_LATESTNEWSENHANCED_GD_LOADED').'</p>';
		}
		
		// Add the script to the document head.
		$doc = JFactory::getDocument();	

		$type = strtolower($this->type);
		
		ob_start();
			require_once dirname(__FILE__) . DS . $type . DS . 'tmpl' . DS . 'default.php';
			$html .= ob_get_contents();
		ob_end_clean();
		
		return $html;
	}

	/**
	 * Method to get the field input markup.
	 *
	 * @return	string	The field input markup.
	 * @since	1.6
	 */
	protected function getInput() {
		return '';
	}

}
?>